diff --git a/src/conn/conn_api.c b/src/conn/conn_api.c
index 65e9cd3b3..e295303cc 100644
--- a/src/conn/conn_api.c
+++ b/src/conn/conn_api.c
@@ -1089,6 +1089,27 @@ __conn_is_new(WT_CONNECTION *wt_conn)
     return (((WT_CONNECTION_IMPL *)wt_conn)->is_new);
 }
 
+/*
+ * __conn_compile_configuration --
+ *     WT_CONNECTION->compile_configuration method.
+ */
+static int
+__conn_compile_configuration(
+  WT_CONNECTION *wt_conn, const char *method, const char *str, const char **compiled)
+{
+    WT_CONNECTION_IMPL *conn;
+    WT_DECL_RET;
+    WT_SESSION_IMPL *session;
+
+    conn = (WT_CONNECTION_IMPL *)wt_conn;
+    CONNECTION_API_CALL_NOCONF(conn, session, compile_configuration);
+
+    ret = __wt_conn_compile_configuration(session, method, str, compiled);
+
+err:
+    API_END_RET_NOTFOUND_MAP(session, ret);
+}
+
 /*
  * __conn_close --
  *     WT_CONNECTION->close method.
@@ -2566,8 +2587,8 @@ wiredtiger_open(const char *home, WT_EVENT_HANDLER *event_handler, const char *c
   WT_CONNECTION **connectionp)
 {
     static const WT_CONNECTION stdc = {__conn_close, __conn_debug_info, __conn_reconfigure,
-      __conn_get_home, __conn_configure_method, __conn_is_new, __conn_open_session,
-      __conn_query_timestamp, __conn_set_timestamp, __conn_rollback_to_stable,
+      __conn_get_home, __conn_configure_method, __conn_is_new, __conn_compile_configuration,
+      __conn_open_session, __conn_query_timestamp, __conn_set_timestamp, __conn_rollback_to_stable,
       __conn_load_extension, __conn_add_data_source, __conn_add_collator, __conn_add_compressor,
       __conn_add_encryptor, __conn_add_extractor, __conn_set_file_system, __conn_add_storage_source,
       __conn_get_storage_source, __conn_get_extension_api};
diff --git a/src/conn/conn_cache.c b/src/conn/conn_cache.c
index bf14fcf49..839d8bfc8 100644
--- a/src/conn/conn_cache.c
+++ b/src/conn/conn_cache.c
@@ -66,29 +66,36 @@ __cache_config_local(WT_SESSION_IMPL *session, bool shared, const char *cfg[])
      * All other settings are independent of whether we are using a shared cache or not.
      */
     if (!shared) {
-        WT_RET(__wt_config_gets(session, cfg, "cache_size", &cval));
+        WT_RET(__wt_config_gets_api(
+          session, cfg, WT_API_CONNECTION_RECONFIGURE_CACHE_SIZE, "cache_size", &cval));
         conn->cache_size = (uint64_t)cval.val;
     }
 
-    WT_RET(__wt_config_gets(session, cfg, "cache_overhead", &cval));
+    WT_RET(__wt_config_gets_api(
+      session, cfg, WT_API_CONNECTION_RECONFIGURE_CACHE_OVERHEAD, "cache_overhead", &cval));
     cache->overhead_pct = (u_int)cval.val;
 
-    WT_RET(__wt_config_gets(session, cfg, "eviction_target", &cval));
+    WT_RET(__wt_config_gets_api(
+      session, cfg, WT_API_CONNECTION_RECONFIGURE_EVICTION_TARGET, "eviction_target", &cval));
     cache->eviction_target = (double)cval.val;
     WT_RET(
       __cache_config_abs_to_pct(session, &(cache->eviction_target), "eviction target", shared));
 
-    WT_RET(__wt_config_gets(session, cfg, "eviction_trigger", &cval));
+    WT_RET(__wt_config_gets_api(
+      session, cfg, WT_API_CONNECTION_RECONFIGURE_EVICTION_TRIGGER, "eviction_trigger", &cval));
     cache->eviction_trigger = (double)cval.val;
     WT_RET(
       __cache_config_abs_to_pct(session, &(cache->eviction_trigger), "eviction trigger", shared));
 
-    WT_RET(__wt_config_gets(session, cfg, "eviction_checkpoint_target", &cval));
+    WT_RET(
+      __wt_config_gets_api(session, cfg, WT_API_CONNECTION_RECONFIGURE_EVICTION_CHECKPOINT_TARGET,
+        "eviction_checkpoint_target", &cval));
     cache->eviction_checkpoint_target = (double)cval.val;
     WT_RET(__cache_config_abs_to_pct(
       session, &(cache->eviction_checkpoint_target), "eviction checkpoint target", shared));
 
-    WT_RET(__wt_config_gets(session, cfg, "eviction_dirty_target", &cval));
+    WT_RET(__wt_config_gets_api(session, cfg, WT_API_CONNECTION_RECONFIGURE_EVICTION_DIRTY_TARGET,
+      "eviction_dirty_target", &cval));
     cache->eviction_dirty_target = (double)cval.val;
     WT_RET(__cache_config_abs_to_pct(
       session, &(cache->eviction_dirty_target), "eviction dirty target", shared));
@@ -106,7 +113,8 @@ __cache_config_local(WT_SESSION_IMPL *session, bool shared, const char *cfg[])
       cache->eviction_checkpoint_target < cache->eviction_dirty_target)
         cache->eviction_checkpoint_target = cache->eviction_dirty_target;
 
-    WT_RET(__wt_config_gets(session, cfg, "eviction_dirty_trigger", &cval));
+    WT_RET(__wt_config_gets_api(session, cfg, WT_API_CONNECTION_RECONFIGURE_EVICTION_DIRTY_TRIGGER,
+      "eviction_dirty_trigger", &cval));
     cache->eviction_dirty_trigger = (double)cval.val;
     WT_RET(__cache_config_abs_to_pct(
       session, &(cache->eviction_dirty_trigger), "eviction dirty trigger", shared));
@@ -119,14 +127,16 @@ __cache_config_local(WT_SESSION_IMPL *session, bool shared, const char *cfg[])
         cache->eviction_dirty_trigger = cache->eviction_trigger;
 
     /* Configure updates target / trigger */
-    WT_RET(__wt_config_gets(session, cfg, "eviction_updates_target", &cval));
+    WT_RET(__wt_config_gets_api(session, cfg, WT_API_CONNECTION_RECONFIGURE_EVICTION_UPDATES_TARGET,
+      "eviction_updates_target", &cval));
     cache->eviction_updates_target = (double)cval.val;
     WT_RET(__cache_config_abs_to_pct(
       session, &(cache->eviction_updates_target), "eviction updates target", shared));
     if (cache->eviction_updates_target < DBL_EPSILON)
         cache->eviction_updates_target = cache->eviction_dirty_target / 2;
 
-    WT_RET(__wt_config_gets(session, cfg, "eviction_updates_trigger", &cval));
+    WT_RET(__wt_config_gets_api(session, cfg,
+      WT_API_CONNECTION_RECONFIGURE_EVICTION_UPDATES_TRIGGER, "eviction_updates_trigger", &cval));
     cache->eviction_updates_trigger = (double)cval.val;
     WT_RET(__cache_config_abs_to_pct(
       session, &(cache->eviction_updates_trigger), "eviction updates trigger", shared));
@@ -137,11 +147,13 @@ __cache_config_local(WT_SESSION_IMPL *session, bool shared, const char *cfg[])
     if (cache->eviction_updates_trigger > cache->eviction_trigger)
         cache->eviction_updates_trigger = cache->eviction_trigger;
 
-    WT_RET(__wt_config_gets(session, cfg, "eviction.threads_max", &cval));
+    WT_RET(__wt_config_gets_api(
+      session, cfg, WT_API_CONNECTION_RECONFIGURE_EVICTION, "eviction.threads_max", &cval));
     WT_ASSERT(session, cval.val > 0);
     evict_threads_max = (uint32_t)cval.val;
 
-    WT_RET(__wt_config_gets(session, cfg, "eviction.threads_min", &cval));
+    WT_RET(__wt_config_gets_api(
+      session, cfg, WT_API_CONNECTION_RECONFIGURE_EVICTION, "eviction.threads_min", &cval));
     WT_ASSERT(session, cval.val > 0);
     evict_threads_min = (uint32_t)cval.val;
 
@@ -152,7 +164,8 @@ __cache_config_local(WT_SESSION_IMPL *session, bool shared, const char *cfg[])
     conn->evict_threads_min = evict_threads_min;
 
     /* Retrieve the wait time and convert from milliseconds */
-    WT_RET(__wt_config_gets(session, cfg, "cache_max_wait_ms", &cval));
+    WT_RET(__wt_config_gets_api(
+      session, cfg, WT_API_CONNECTION_RECONFIGURE_CACHE_MAX_WAIT_MS, "cache_max_wait_ms", &cval));
     cache->cache_max_wait_us = (uint64_t)(cval.val * WT_THOUSAND);
 
     return (0);
diff --git a/src/conn/conn_compiled.c b/src/conn/conn_compiled.c
new file mode 100644
index 000000000..a11452afd
--- /dev/null
+++ b/src/conn/conn_compiled.c
@@ -0,0 +1,372 @@
+/*-
+ * Copyright (c) 2014-present MongoDB, Inc.
+ * Copyright (c) 2008-2014 WiredTiger, Inc.
+ *	All rights reserved.
+ *
+ * See the file LICENSE for redistribution information.
+ */
+
+#include "wt_internal.h"
+
+/*
+ * __wt_compiled_config_init --
+ *     Initialize compiled configuration.
+ */
+int
+__wt_compiled_config_init(WT_SESSION_IMPL *session, const char **cfg)
+{
+    WT_CONFIG_ITEM cval;
+    WT_CONNECTION_IMPL *conn;
+    char *cs;
+#if 0
+    size_t i, lastlen;
+#endif
+
+    conn = S2C(session);
+    WT_RET(__wt_config_gets(session, cfg, "compile_configuration_count", &cval));
+    conn->compiled_max = (size_t)cval.val;
+
+    /*
+     * Compiled strings will look like some number of '~'s, with offset number at every ten:
+     *    "0~~~~~~~~~10~~~~~~~~20..."
+     * By design, this will give a configuration error if mistakenly interpreted directly, and
+     * makes it easier to debug.
+     */
+    WT_RET(__wt_calloc(session, conn->compiled_max + 2, 1, &cs));
+#if 1
+    memset(cs, 'Z', conn->compiled_max + 1);
+#else
+    memset(cs, '~', conn->compiled_max + 1);
+    lastlen = 1;
+    for (i = 0; i < conn->compiled_max - lastlen - 2; i += 10) {
+        WT_RET(__wt_snprintf_len_set(
+          &cs[i], conn->compiled_max - i - lastlen - 2, &lastlen, "%d", (int)i));
+        cs[i + lastlen] = '~';
+    }
+#endif
+    conn->compiled_config_current = conn->compiled_config_str = cs;
+
+    return (0);
+}
+
+/*
+ * __conn_compiled_free --
+ *     Free one compiled item.
+ */
+static void
+__conn_compiled_free(WT_SESSION_IMPL *session, WT_COMPILED *compiled)
+{
+    if (compiled != NULL) {
+        /*
+         * When an 'unbound' entry is created, and 'bound' entry is created in the next slot. They
+         * share pointers, so don't free the parts twice.
+         */
+        if (compiled->unbound == 0)
+            __wt_free(session, compiled->orig_config);
+
+        __wt_free(session, compiled);
+    }
+}
+
+/*
+ * __wt_compiled_bound_free --
+ *     Free all bound entries in the session.
+ */
+void
+__wt_compiled_bound_free(WT_SESSION_IMPL *session)
+{
+    WT_CONNECTION_IMPL *conn;
+    uint32_t i;
+
+    conn = S2C(session);
+
+    if (session->compiled_bound != NULL) {
+        for (i = 0; i < conn->compiled_unbound_cnt; ++i)
+            __wt_free(session, session->compiled_bound[i].values);
+        __wt_free(session, session->compiled_bound);
+    }
+}
+
+/*
+ * __conn_compiled_value --
+ *     Compile a value into the compiled struct.
+ */
+static int
+__conn_compiled_value(WT_SESSION_IMPL *session, WT_COMPILED *compiled, u_int pos,
+  const WT_CONFIG_CHECK *check, WT_CONFIG_ITEM *value)
+{
+    WT_COMPILED_VALUE *comp_value;
+    u_int bind_num, compiled_type;
+
+    comp_value = &compiled->values[pos];
+    comp_value->item = *value;
+    compiled_type = check->compiled_type;
+    if (value->type == WT_CONFIG_ITEM_ID && value->len > 0 && value->str[0] == '%') {
+        compiled->unbound |= (uint64_t)(1 << pos);
+        bind_num = compiled->bind_desc_cnt++;
+        WT_RET(__wt_realloc_def(
+          session, &compiled->bind_desc_size, compiled->bind_desc_cnt, &compiled->bind_desc));
+        compiled->bind_desc[bind_num].offset = pos;
+        if (value->str[1] == 'd')
+            compiled->bind_desc[bind_num].type = WT_CONFIG_ITEM_NUM;
+        else if (value->str[1] == 's')
+            compiled->bind_desc[bind_num].type = WT_CONFIG_ITEM_STRING;
+        else
+            WT_RET_MSG(session, EINVAL, "Value '%.*s' does not match %s for binding",
+              (int)value->len, value->str, "%d or %s");
+    } else
+        switch (compiled_type) {
+        case WT_CONFIG_COMPILED_TYPE_INT:
+            if (value->type != WT_CONFIG_ITEM_NUM)
+                WT_RET_MSG(session, EINVAL, "Value '%.*s' expected to be an integer",
+                  (int)value->len, value->str);
+            break;
+        case WT_CONFIG_COMPILED_TYPE_BOOLEAN:
+            if (value->type != WT_CONFIG_ITEM_BOOL &&
+              (value->type != WT_CONFIG_ITEM_NUM || (value->val != 0 && value->val != 1)))
+                WT_RET_MSG(session, EINVAL, "Value '%.*s' expected to be a boolean",
+                  (int)value->len, value->str);
+            break;
+        case WT_CONFIG_COMPILED_TYPE_STRING:
+            if (value->type != WT_CONFIG_ITEM_STRING && value->type != WT_CONFIG_ITEM_ID)
+                WT_RET_MSG(session, EINVAL, "Value '%.*s' expected to be a string", (int)value->len,
+                  value->str);
+            break;
+        case WT_CONFIG_COMPILED_TYPE_CATEGORY:
+            if (value->type != WT_CONFIG_ITEM_STRUCT || value->str[0] != '[')
+                WT_RET_MSG(session, EINVAL, "Value '%.*s' expected to be a category",
+                  (int)value->len, value->str);
+            break;
+        case WT_CONFIG_COMPILED_TYPE_LIST:
+            if (value->type != WT_CONFIG_ITEM_STRUCT || value->str[0] != '[')
+                WT_RET_MSG(session, EINVAL, "Value '%.*s' expected to be a list", (int)value->len,
+                  value->str);
+            break;
+        default:
+            return (__wt_illegal_value(session, compiled_type));
+            break;
+        }
+    return (0);
+}
+
+/*
+ * __wt_compiled_config_discard --
+ *     Discard compiled configuration info.
+ */
+void
+__wt_compiled_config_discard(WT_SESSION_IMPL *session)
+{
+    WT_CONNECTION_IMPL *conn;
+    uint32_t i;
+
+    conn = S2C(session);
+    __wt_free(session, conn->compiled_config_str);
+    if (conn->compiled_array != NULL) {
+        for (i = 0; i < conn->compiled_cnt; ++i)
+            __conn_compiled_free(session, conn->compiled_array[i]);
+        __wt_free(session, conn->compiled_array);
+    }
+}
+
+/*
+ * __wt_conn_compile_configuration --
+ *     Compile a configuration string, returning a string that can be used in the API.
+ */
+int
+__wt_conn_compile_configuration(
+  WT_SESSION_IMPL *session, const char *method, const char *str, const char **compiled_str)
+{
+    WT_COMPILED *compiled, *compiled_bind;
+    WT_CONFIG parser;
+    const WT_CONFIG_CHECK *check;
+    const WT_CONFIG_ENTRY *centry;
+    WT_CONFIG_ITEM key, value;
+    WT_CONNECTION_IMPL *conn;
+    WT_DECL_RET;
+    uint32_t count, i;
+
+    conn = S2C(session);
+    compiled = compiled_bind = NULL;
+
+    /* TODO: we need to lock the data structures in connection */
+    if (conn->compiled_cnt >= conn->compiled_max)
+        WT_RET_MSG(session, EINVAL,
+          "Error compiling '%s', overflowed maximum compile slots of %" PRIuMAX, str,
+          conn->compiled_max);
+
+    centry = __wt_conn_config_match(method);
+    if (centry == NULL)
+        WT_RET_MSG(session, EINVAL, "Error compiling configuration, unknown method '%s'", method);
+    if (!centry->compilable)
+        WT_RET_MSG(session, ENOTSUP,
+          "Error compiling, method '%s' does not support compiled configurations", method);
+    /* Make sure there is an extra bind entry */
+    WT_RET(__wt_realloc_def(
+      session, &conn->compiled_size, conn->compiled_cnt + 2, &conn->compiled_array));
+    WT_RET(__wt_calloc_one(session, &compiled));
+
+    compiled->config_entry = centry;
+    compiled->bind_link = -1;
+
+    /*
+     * Keep a copy of the original configuration string, as the caller may reuse their own string.
+     */
+    WT_ERR(__wt_strdup(session, str, &compiled->orig_config));
+
+    /*
+     * Walk through the given configuration string, for each key, look it up. We should find it in
+     * the configuration checks array, and the index in that array is both the bit position to flip
+     * in the 'set' array, and the position in the values table where we will compile the value.
+     */
+    __wt_config_init(session, &parser, compiled->orig_config);
+    count = 0;
+    while ((ret = __wt_config_next(&parser, &key, &value)) == 0) {
+        for (i = 0; i < centry->checks_entries; ++i) {
+            check = &centry->checks[i];
+            if (WT_STRING_MATCH(check->name, key.str, key.len)) {
+                compiled->set |= (uint64_t)(1 << i);
+                WT_ERR(__wt_realloc_def(session, &compiled->values_size, i + 1, &compiled->values));
+                WT_ERR(__conn_compiled_value(session, compiled, i, check, &value));
+                break;
+            }
+        }
+        if (i == centry->checks_entries)
+            WT_ERR_MSG(session, EINVAL, "Error compiling '%s', unknown key '%.*s' for method '%s'",
+              str, (int)key.len, key.str, method);
+
+        if (++count > 64) /* bit overflow */
+            /* TODO: we should do a sanity check when parsing api_data.py */
+            WT_ERR_MSG(session, EINVAL, "Error compiling '%s', too many keys", str);
+    }
+    if (compiled->unbound != 0) {
+        WT_ERR(__wt_calloc_one(session, &compiled_bind));
+        *compiled_bind = *compiled; /* structure assign */
+        compiled_bind->unbound = 0;
+        compiled_bind->bind_link = conn->compiled_unbound_cnt++; /* TODO - potentially wasteful */
+    }
+    WT_ERR_NOTFOUND_OK(ret, false);
+
+err:
+    if (ret == 0) {
+        conn->compiled_array[conn->compiled_cnt++] = compiled;
+        *compiled_str = conn->compiled_config_current++;
+        if (compiled_bind) {
+            conn->compiled_array[conn->compiled_cnt++] = compiled_bind;
+            ++conn->compiled_config_current;
+        }
+    } else {
+        __conn_compiled_free(session, compiled);
+        __conn_compiled_free(session, compiled_bind);
+    }
+
+    return (ret);
+}
+
+/*
+ * __wt_compiled_bind --
+ *     Bind values to a configuration string.
+ */
+int
+__wt_compiled_bind(
+  WT_SESSION_IMPL *session, const char *compiled_str, const char **bound_str, va_list ap)
+{
+    WT_COMPILED *compiled, *compiled_bind;
+    WT_COMPILED_BIND_DESC *bind_desc;
+    WT_COMPILED_BOUND *bound;
+    WT_CONNECTION_IMPL *conn;
+    uint64_t i;
+    u_int offset, voffset;
+    int bind_link;
+    const char *str;
+
+    conn = S2C(session);
+    WT_ASSERT(session, __wt_is_compiled_config(conn, compiled_str));
+    offset = (compiled_str - (conn)->compiled_config_str);
+    compiled = conn->compiled_array[offset];
+    if (compiled->unbound == 0)
+        WT_RET_MSG(session, EINVAL, "configuration has no bindings");
+    /* The next entry is the binding one */
+    compiled_bind = conn->compiled_array[offset + 1];
+
+    bind_link = compiled_bind->bind_link; /* TODO, may want to rotate, etc. */
+    if (bind_link < 0)
+        WT_RET_MSG(session, EINVAL, "missing bound entry");
+    if ((u_int)bind_link > conn->compiled_unbound_cnt)
+        WT_RET_MSG(session, EINVAL, "bad bind link");
+
+    /* TODO: must freeze. */
+    if (session->compiled_bound == NULL)
+        WT_RET(__wt_calloc_def(session, conn->compiled_unbound_cnt + 1, &session->compiled_bound));
+
+    bound = &session->compiled_bound[bind_link];
+    bound->compiled = compiled_bind;
+    /* TODO: The original is over-allocated, so this is wasteful */
+    WT_RET(__wt_realloc_def(session, &bound->values_size,
+      compiled->values_size / sizeof(compiled->values[0]), &bound->values));
+
+    // Copy all the values, then bind them one by one.
+    memcpy(bound->values, compiled->values, compiled->values_size);
+    for (i = 0; i < compiled->bind_desc_cnt; ++i) {
+        bind_desc = &compiled->bind_desc[i];
+        voffset = bind_desc->offset;
+        switch (bind_desc->type) {
+        case WT_CONFIG_ITEM_NUM:
+        case WT_CONFIG_ITEM_BOOL:
+            /* The str/len fields will continue to be set to "%d" in our copy of the config string.
+             */
+            bound->values[voffset].item.val = va_arg(ap, int64_t);
+            break;
+        case WT_CONFIG_ITEM_STRING:
+        case WT_CONFIG_ITEM_ID:
+            str = va_arg(ap, const char *);
+            bound->values[voffset].item.str = str;
+            bound->values[voffset].item.len = strlen(str);
+            break;
+        default:
+            return (__wt_illegal_value(session, bind_desc->type));
+        }
+        bound->values[voffset].item.type = (enum __wt_config_item_enum)bind_desc->type;
+    }
+
+    *bound_str = compiled_str + 1; /* Return the bind slot */
+    return (0);
+}
+
+/*
+ * __wt_compiled_get --
+ *     Get a value for the compiled string.
+ */
+int
+__wt_compiled_get(
+  WT_SESSION_IMPL *session, int api, const char *compiled_str, WT_CONFIG_ITEM *value)
+{
+    WT_COMPILED_BOUND *bound;
+    WT_COMPILED_VALUE *comp_value;
+    const WT_COMPILED *compiled;
+    WT_CONNECTION_IMPL *conn;
+    u_int offset;
+
+    conn = S2C(session);
+    bound = NULL;
+    WT_ASSERT(session, __wt_is_compiled_config(conn, compiled_str));
+    offset = (compiled_str - (conn)->compiled_config_str);
+    compiled = (conn)->compiled_array[offset];
+    WT_ASSERT(session, (compiled->set & (uint64_t)(1 << api)) != 0);
+
+    if (compiled->unbound != 0)
+        WT_RET_MSG(session, EINVAL, "reference to unbound configuration");
+    if (compiled->bind_link >= 0) {
+        if (session->compiled_bound == NULL ||
+          session->compiled_bound[compiled->bind_link].values == NULL)
+            WT_RET_MSG(session, EINVAL, "reference to unknown bound configuration");
+        bound = &session->compiled_bound[compiled->bind_link];
+        comp_value = &bound->values[api];
+    } else
+        comp_value = &compiled->values[api];
+
+    if (compiled->config_entry->method_id != session->api_method_id)
+        WT_RET_MSG(session, EINVAL, "configuration string compiled for incorrect API");
+
+    *value = comp_value->item;
+    return (0);
+}
diff --git a/src/conn/conn_handle.c b/src/conn/conn_handle.c
index bb5b7e27b..66786868e 100644
--- a/src/conn/conn_handle.c
+++ b/src/conn/conn_handle.c
@@ -106,6 +106,9 @@ __wt_connection_destroy(WT_CONNECTION_IMPL *conn)
     TAILQ_REMOVE(&__wt_process.connqh, conn, q);
     __wt_spin_unlock(session, &__wt_process.spinlock);
 
+    /* Compiled configuration */
+    __wt_compiled_config_discard(session);
+
     /* Configuration */
     __wt_conn_config_discard(session); /* configuration */
 
diff --git a/src/conn/conn_open.c b/src/conn/conn_open.c
index 5b89817c9..c180b54af 100644
--- a/src/conn/conn_open.c
+++ b/src/conn/conn_open.c
@@ -47,6 +47,9 @@ __wt_connection_open(WT_CONNECTION_IMPL *conn, const char *cfg[])
      */
     WT_WRITE_BARRIER();
 
+    /* Set up compiled configuration strings. */
+    WT_RET(__wt_compiled_config_init(session, cfg));
+
     /* Create the cache. */
     WT_RET(__wt_cache_create(session, cfg));
 
diff --git a/src/conn/conn_reconfig.c b/src/conn/conn_reconfig.c
index 14378f1d7..f5be715d2 100644
--- a/src/conn/conn_reconfig.c
+++ b/src/conn/conn_reconfig.c
@@ -53,7 +53,8 @@ __wt_conn_compat_config(WT_SESSION_IMPL *session, const char **cfg, bool reconfi
     new_compat = min_compat = max_compat = WT_NO_VERSION;
     unchg = false;
 
-    WT_RET(__wt_config_gets(session, cfg, "compatibility.release", &cval));
+    WT_RET(__wt_config_gets_api(
+      session, cfg, WT_API_CONNECTION_RECONFIGURE_COMPATIBILITY, "compatibility.release", &cval));
     if (cval.len == 0) {
         new_compat.major = WIREDTIGER_VERSION_MAJOR;
         new_compat.minor = WIREDTIGER_VERSION_MINOR;
@@ -88,11 +89,13 @@ __wt_conn_compat_config(WT_SESSION_IMPL *session, const char **cfg, bool reconfi
      * The maximum and minimum required version for existing files is only available on opening the
      * connection, not reconfigure.
      */
-    WT_RET(__wt_config_gets(session, cfg, "compatibility.require_min", &cval));
+    WT_RET(__wt_config_gets_api(session, cfg, WT_API_CONNECTION_RECONFIGURE_COMPATIBILITY,
+      "compatibility.require_min", &cval));
     if (cval.len != 0)
         WT_RET(__conn_compat_parse(session, &cval, &min_compat.major, &min_compat.minor));
 
-    WT_RET(__wt_config_gets(session, cfg, "compatibility.require_max", &cval));
+    WT_RET(__wt_config_gets_api(session, cfg, WT_API_CONNECTION_RECONFIGURE_COMPATIBILITY,
+      "compatibility.require_max", &cval));
     if (cval.len != 0)
         WT_RET(__conn_compat_parse(session, &cval, &max_compat.major, &max_compat.minor));
 
@@ -211,11 +214,13 @@ __wt_conn_optrack_setup(WT_SESSION_IMPL *session, const char *cfg[], bool reconf
 
     /* Once an operation tracking path has been set it can't be changed. */
     if (!reconfig) {
-        WT_RET(__wt_config_gets(session, cfg, "operation_tracking.path", &cval));
+        WT_RET(__wt_config_gets_api(session, cfg, WT_API_CONNECTION_RECONFIGURE_OPERATION_TRACKING,
+          "operation_tracking.path", &cval));
         WT_RET(__wt_strndup(session, cval.str, cval.len, &conn->optrack_path));
     }
 
-    WT_RET(__wt_config_gets(session, cfg, "operation_tracking.enabled", &cval));
+    WT_RET(__wt_config_gets_api(session, cfg, WT_API_CONNECTION_RECONFIGURE_OPERATION_TRACKING,
+      "operation_tracking.enabled", &cval));
     if (cval.val == 0) {
         if (F_ISSET(conn, WT_CONN_OPTRACK)) {
             WT_RET(__wt_conn_optrack_teardown(session, reconfig));
@@ -302,7 +307,8 @@ __wt_conn_statistics_config(WT_SESSION_IMPL *session, const char *cfg[])
 
     conn = S2C(session);
 
-    WT_RET(__wt_config_gets(session, cfg, "statistics", &cval));
+    WT_RET(__wt_config_gets_api(
+      session, cfg, WT_API_CONNECTION_RECONFIGURE_STATISTICS, "statistics", &cval));
 
     flags = 0;
     set = 0;
diff --git a/src/cursor/cur_file.c b/src/cursor/cur_file.c
index d373c089c..a462a12fe 100644
--- a/src/cursor/cur_file.c
+++ b/src/cursor/cur_file.c
@@ -716,14 +716,16 @@ __curfile_create(WT_SESSION_IMPL *session, WT_CURSOR *owner, const char *cfg[],
         cbulk = (WT_CURSOR_BULK *)cbt;
 
         /* Optionally skip the validation of each bulk-loaded key. */
-        WT_ERR(__wt_config_gets_def(session, cfg, "skip_sort_check", 0, &cval));
+        WT_ERR(__wt_config_gets_def_api(
+          session, cfg, WT_API_SESSION_OPEN_CURSOR_SKIP_SORT_CHECK, "skip_sort_check", 0, &cval));
         WT_ERR(__wt_curbulk_init(session, cbulk, bitmap, cval.val == 0 ? 0 : 1));
     }
 
     /*
      * Random retrieval, row-store only. Random retrieval cursors support a limited set of methods.
      */
-    WT_ERR(__wt_config_gets_def(session, cfg, "next_random", 0, &cval));
+    WT_ERR(__wt_config_gets_def_api(
+      session, cfg, WT_API_SESSION_OPEN_CURSOR_NEXT_RANDOM, "next_random", 0, &cval));
     if (cval.val != 0) {
         if (WT_CURSOR_RECNO(cursor))
             WT_ERR_MSG(
@@ -733,13 +735,15 @@ __curfile_create(WT_SESSION_IMPL *session, WT_CURSOR *owner, const char *cfg[],
         cursor->next = __wt_curfile_next_random;
         cursor->reset = __curfile_reset;
 
-        WT_ERR(__wt_config_gets_def(session, cfg, "next_random_sample_size", 0, &cval));
+        WT_ERR(__wt_config_gets_def_api(session, cfg,
+          WT_API_SESSION_OPEN_CURSOR_NEXT_RANDOM_SAMPLE_SIZE, "next_random_sample_size", 0, &cval));
         if (cval.val != 0)
             cbt->next_random_sample_size = (u_int)cval.val;
         cacheable = false;
     }
 
-    WT_ERR(__wt_config_gets_def(session, cfg, "read_once", 0, &cval));
+    WT_ERR(__wt_config_gets_def_api(
+      session, cfg, WT_API_SESSION_OPEN_CURSOR_READ_ONCE, "read_once", 0, &cval));
     if (cval.val != 0)
         F_SET(cbt, WT_CBT_READ_ONCE);
 
@@ -793,6 +797,7 @@ __wt_curfile_open(WT_SESSION_IMPL *session, const char *uri, WT_CURSOR *owner, c
     bool bitmap, bulk, checkpoint_wait;
 
     bitmap = bulk = false;
+
     checkpoint_wait = true;
     flags = 0;
 
@@ -800,7 +805,8 @@ __wt_curfile_open(WT_SESSION_IMPL *session, const char *uri, WT_CURSOR *owner, c
      * Decode the bulk configuration settings. In memory databases ignore bulk load.
      */
     if (!F_ISSET(S2C(session), WT_CONN_IN_MEMORY)) {
-        WT_RET(__wt_config_gets_def(session, cfg, "bulk", 0, &cval));
+        WT_RET(__wt_config_gets_def_api(
+          session, cfg, WT_API_SESSION_OPEN_CURSOR_BULK, "bulk", 0, &cval));
         if (cval.type == WT_CONFIG_ITEM_BOOL ||
           (cval.type == WT_CONFIG_ITEM_NUM && (cval.val == 0 || cval.val == 1))) {
             bitmap = false;
